/**
 * Copyright (c) 2015-2017 Obeo, Inria
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 	
 * Contributors:
 * - William Piers <william.piers@obeo.fr>
 * - Philippe Merle <philippe.merle@inria.fr>
 * - Faiez Zalila <faiez.zalila@inria.fr>
 */
package monitoring;

import org.modmacao.occi.platform.Component;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Datagatherer</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * DataGatherer Resource
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link monitoring.Datagatherer#getOcciCollectorPeriod <em>Occi Collector Period</em>}</li>
 *   <li>{@link monitoring.Datagatherer#getOcciCollectorGranularity <em>Occi Collector Granularity</em>}</li>
 *   <li>{@link monitoring.Datagatherer#getOcciCollectorAccuracy <em>Occi Collector Accuracy</em>}</li>
 * </ul>
 *
 * @see monitoring.MonitoringPackage#getDatagatherer()
 * @model
 * @generated
 */
public interface Datagatherer extends Component {
	/**
	 * Returns the value of the '<em><b>Occi Collector Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Time between two following measurements (seconds).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Collector Period</em>' attribute.
	 * @see #setOcciCollectorPeriod(String)
	 * @see monitoring.MonitoringPackage#getDatagatherer_OcciCollectorPeriod()
	 * @model dataType="monitoring.Second" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Datagatherer!occiCollectorPeriod'"
	 * @generated
	 */
	String getOcciCollectorPeriod();

	/**
	 * Sets the value of the '{@link monitoring.Datagatherer#getOcciCollectorPeriod <em>Occi Collector Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Collector Period</em>' attribute.
	 * @see #getOcciCollectorPeriod()
	 * @generated
	 */
	void setOcciCollectorPeriod(String value);

	/**
	 * Returns the value of the '<em><b>Occi Collector Granularity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Granularity of time measurement (seconds).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Collector Granularity</em>' attribute.
	 * @see #setOcciCollectorGranularity(String)
	 * @see monitoring.MonitoringPackage#getDatagatherer_OcciCollectorGranularity()
	 * @model dataType="monitoring.Second"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Datagatherer!occiCollectorGranularity'"
	 * @generated
	 */
	String getOcciCollectorGranularity();

	/**
	 * Sets the value of the '{@link monitoring.Datagatherer#getOcciCollectorGranularity <em>Occi Collector Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Collector Granularity</em>' attribute.
	 * @see #getOcciCollectorGranularity()
	 * @generated
	 */
	void setOcciCollectorGranularity(String value);

	/**
	 * Returns the value of the '<em><b>Occi Collector Accuracy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Accuracy of time measurement (seconds).
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Occi Collector Accuracy</em>' attribute.
	 * @see #setOcciCollectorAccuracy(String)
	 * @see monitoring.MonitoringPackage#getDatagatherer_OcciCollectorAccuracy()
	 * @model dataType="monitoring.Second"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://schemas.ugoe.cs.rwm/monitoring/ecore!Datagatherer!occiCollectorAccuracy'"
	 * @generated
	 */
	String getOcciCollectorAccuracy();

	/**
	 * Sets the value of the '{@link monitoring.Datagatherer#getOcciCollectorAccuracy <em>Occi Collector Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Occi Collector Accuracy</em>' attribute.
	 * @see #getOcciCollectorAccuracy()
	 * @generated
	 */
	void setOcciCollectorAccuracy(String value);

} // Datagatherer
