/**
 * Copyright (c) 2015-2017 Obeo, Inria
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 	
 * Contributors:
 * - William Piers <william.piers@obeo.fr>
 * - Philippe Merle <philippe.merle@inria.fr>
 * - Faiez Zalila <faiez.zalila@inria.fr>
 */
package monitoring.impl;

import monitoring.Datagatherer;
import monitoring.MonitoringPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.modmacao.occi.platform.impl.ComponentImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Datagatherer</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link monitoring.impl.DatagathererImpl#getOcciCollectorPeriod <em>Occi Collector Period</em>}</li>
 *   <li>{@link monitoring.impl.DatagathererImpl#getOcciCollectorGranularity <em>Occi Collector Granularity</em>}</li>
 *   <li>{@link monitoring.impl.DatagathererImpl#getOcciCollectorAccuracy <em>Occi Collector Accuracy</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DatagathererImpl extends ComponentImpl implements Datagatherer {
	/**
	 * The default value of the '{@link #getOcciCollectorPeriod() <em>Occi Collector Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOcciCollectorPeriod()
	 * @generated
	 * @ordered
	 */
	protected static final String OCCI_COLLECTOR_PERIOD_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOcciCollectorPeriod() <em>Occi Collector Period</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOcciCollectorPeriod()
	 * @generated
	 * @ordered
	 */
	protected String occiCollectorPeriod = OCCI_COLLECTOR_PERIOD_EDEFAULT;

	/**
	 * The default value of the '{@link #getOcciCollectorGranularity() <em>Occi Collector Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOcciCollectorGranularity()
	 * @generated
	 * @ordered
	 */
	protected static final String OCCI_COLLECTOR_GRANULARITY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOcciCollectorGranularity() <em>Occi Collector Granularity</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOcciCollectorGranularity()
	 * @generated
	 * @ordered
	 */
	protected String occiCollectorGranularity = OCCI_COLLECTOR_GRANULARITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getOcciCollectorAccuracy() <em>Occi Collector Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOcciCollectorAccuracy()
	 * @generated
	 * @ordered
	 */
	protected static final String OCCI_COLLECTOR_ACCURACY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOcciCollectorAccuracy() <em>Occi Collector Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOcciCollectorAccuracy()
	 * @generated
	 * @ordered
	 */
	protected String occiCollectorAccuracy = OCCI_COLLECTOR_ACCURACY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DatagathererImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MonitoringPackage.Literals.DATAGATHERER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOcciCollectorPeriod() {
		return occiCollectorPeriod;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOcciCollectorPeriod(String newOcciCollectorPeriod) {
		String oldOcciCollectorPeriod = occiCollectorPeriod;
		occiCollectorPeriod = newOcciCollectorPeriod;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_PERIOD, oldOcciCollectorPeriod, occiCollectorPeriod));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOcciCollectorGranularity() {
		return occiCollectorGranularity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOcciCollectorGranularity(String newOcciCollectorGranularity) {
		String oldOcciCollectorGranularity = occiCollectorGranularity;
		occiCollectorGranularity = newOcciCollectorGranularity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_GRANULARITY, oldOcciCollectorGranularity, occiCollectorGranularity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getOcciCollectorAccuracy() {
		return occiCollectorAccuracy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOcciCollectorAccuracy(String newOcciCollectorAccuracy) {
		String oldOcciCollectorAccuracy = occiCollectorAccuracy;
		occiCollectorAccuracy = newOcciCollectorAccuracy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_ACCURACY, oldOcciCollectorAccuracy, occiCollectorAccuracy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_PERIOD:
				return getOcciCollectorPeriod();
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_GRANULARITY:
				return getOcciCollectorGranularity();
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_ACCURACY:
				return getOcciCollectorAccuracy();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_PERIOD:
				setOcciCollectorPeriod((String)newValue);
				return;
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_GRANULARITY:
				setOcciCollectorGranularity((String)newValue);
				return;
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_ACCURACY:
				setOcciCollectorAccuracy((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_PERIOD:
				setOcciCollectorPeriod(OCCI_COLLECTOR_PERIOD_EDEFAULT);
				return;
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_GRANULARITY:
				setOcciCollectorGranularity(OCCI_COLLECTOR_GRANULARITY_EDEFAULT);
				return;
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_ACCURACY:
				setOcciCollectorAccuracy(OCCI_COLLECTOR_ACCURACY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_PERIOD:
				return OCCI_COLLECTOR_PERIOD_EDEFAULT == null ? occiCollectorPeriod != null : !OCCI_COLLECTOR_PERIOD_EDEFAULT.equals(occiCollectorPeriod);
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_GRANULARITY:
				return OCCI_COLLECTOR_GRANULARITY_EDEFAULT == null ? occiCollectorGranularity != null : !OCCI_COLLECTOR_GRANULARITY_EDEFAULT.equals(occiCollectorGranularity);
			case MonitoringPackage.DATAGATHERER__OCCI_COLLECTOR_ACCURACY:
				return OCCI_COLLECTOR_ACCURACY_EDEFAULT == null ? occiCollectorAccuracy != null : !OCCI_COLLECTOR_ACCURACY_EDEFAULT.equals(occiCollectorAccuracy);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (occiCollectorPeriod: ");
		result.append(occiCollectorPeriod);
		result.append(", occiCollectorGranularity: ");
		result.append(occiCollectorGranularity);
		result.append(", occiCollectorAccuracy: ");
		result.append(occiCollectorAccuracy);
		result.append(')');
		return result.toString();
	}

} //DatagathererImpl
